# General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
# base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
# The model can simulate OLEDs, Perovskite cells, and OFETs.
# 
# Copyright (C) 2008-2020 Roderick C. I. MacKenzie
# All rights reserved.
# 
# https://www.gpvdm.com
# r.c.i.mackenzie at googlemail.com
# 
# 
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above copyright
#       notice, this list of conditions and the following disclaimer in the
#       documentation and/or other materials provided with the distribution.
#     * Neither the name of the GPVDM nor the
#       names of its contributors may be used to endorse or promote products
#       derived from this software without specific prior written permission.
# 
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
# DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
# DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


import socket, select, string, sys
import os
import socket
import sys
import multiprocessing
import threading
from inp import inp_get_token_value
from time import sleep
import SocketServer
from util import join_path

respond_ip=""
respond_port=0
output_path=""

def encode_for_tcp(l):
	#Make it 4 bytes long
	l = str(l)
	while len(l) < 200:
		l = l+" "
	return l

def ensure_dir(f):
	d = os.path.dirname(f)
	if not os.path.exists(d):
		os.makedirs(d)
		#print "making dir",d

class MyTCPHandler(SocketServer.BaseRequestHandler):

	def handle(self):
		global output_path
		print "Receiving files"
		buf=""
		while True:
			data = self.request.recv(1024)
	  		if data:
				buf=buf+data
	    		else:
				#print "zero length packet",len(buf)
				break

			#print len(buf)
		print "buffer len",len(buf)
		if len(buf)==0:
			print "I have recived a zero length buffer"

		#self.request.close()

		pos=0
		job_name=buf[pos:pos+200].rstrip()

		pos=pos+200
		n=0
		frag_error=False
		frag_error_text=""
		while True:
			if pos+200<len(buf):
				name=buf[pos:pos+200].rstrip()
			else:
				frag_error=True
				break

			#print "Name",buf[pos:pos+200]
			pos=pos+200
			#print "Length",buf[pos:pos+200]

			if pos+200<len(buf):
				length=int(buf[pos:pos+200].rstrip())
			else:
				frag_error=True
				break

			pos=pos+200

			if pos+length>len(buf):
				frag_error=True
				break

			#print "Joining ", output_path,name
			output_file=join_path(output_path,name)
			#print "Writing file:"+output_file+"<"
			#print "Output path:"+output_path+"<"
			path=os.path.dirname(output_file)
			#print "name:"+name+"<"
			#print "test:"+os.path.join(output_path,name)+"<"
			ensure_dir(output_file)

			out=open(output_file, 'wb')
			read_in=buf[pos:pos+length]
			de_comp=read_in.decode("zlib")
			out.write(de_comp)
			out.close()
			if n==0:
 				print "{} wrote:".format(self.client_address[0])
				print "Rx file:"+name

			n=n+1

			if output_file.endswith("go.o"):
				os.chmod(output_file, 0777)

			pos=pos+length
			if pos>=len(buf):
				break

		del(buf)

		if frag_error==True:
			print "Data fragmentation error!!!!!!!!!!!!!!!!!!!!!!!!"

		#sleep(0.5)
		if job_name!="":
			if respond_ip!="":
				#print os.path.isdir("/home/rod/liz/orig/otest//home/rod/liz/orig/high_recombination_mobility/1e-8/200")
				#print "Ready!!!!!!!!"
				s = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
				s.sendto("iwanttorun#"+job_name, (respond_ip, respond_port))
				s.close()

class listen_for_files_on_network():



	def init(self,dump_path,port):
		global output_path
		if dump_path!="":
			output_path=os.path.abspath(dump_path)
		else:
			output_path=""
		print "output_path:"+output_path
		self.port=port
		self.thread = threading.Thread(target = self.listen)
		self.thread.daemon = True
		self.thread.start()

	def respond(self,in_respond_ip,in_respond_port):
		global respond_ip
		global respond_port
		respond_ip=in_respond_ip
		respond_port=in_respond_port

	def listen(self):
		print "TCP file server running"
		server = SocketServer.TCPServer(('', self.port), MyTCPHandler)
		server.serve_forever()



